//
//  BFRSComm.swift
//  BFRecordScreenKit
//
//  Created by 胡志强 on 2021/11/23.
//

import Foundation

import BFCommonKit
import AVFoundation

// class BFUIConfig{}

public func imageInRecordScreenKit(by name: String) -> UIImage? {
    return UIImage(named: name, in: currentBundle(), compatibleWith: nil)
}

func currentBundle() -> Bundle? {
    return Bundle.current(moduleName: "BFRecordScreenKit", isAssets: false)
}

// func ThemeStyleGreen() -> UIColor {
//    return UIColor.hexColor(hexadecimal: "#389AFF")
// }
public var ThemeStyleColor = UIColor.hexColor(hexadecimal: "#389AFF")


// 获取视频资源的旋转方向
public func degressFromVideoFile(asset: AVAsset) -> UInt {
    var degress :UInt = 0
    let tracks = asset.tracks(withMediaType: .video)
    if let track = tracks.first {
        let t = track.preferredTransform
        
        if(t.a == 0 && t.b == 1.0 && t.c == -1.0 && t.d == 0){
            // Portrait
            degress = 90;
        }else if(t.a == 0 && t.b == -1.0 && t.c == 1.0 && t.d == 0){
            // PortraitUpsideDown
            degress = 270;
        }else if(t.a == 1.0 && t.b == 0 && t.c == 0 && t.d == 1.0){
            // LandscapeRight
            degress = 0;
        }else if(t.a == -1.0 && t.b == 0 && t.c == 0 && t.d == -1.0){
            // LandscapeLeft
            degress = 180;
        }
    }
    
    
    return degress
}

