//
//  BFRecordScreenBaseManager.swift
//  BFRecordScreenKit
//
//  Created by 胡志强 on 2022/1/13.
//

import Foundation
import GPUImage
import BFCommonKit
import BFMediaKit


class BFRecordScreenBaseManager : NSObject{
    
    weak var dele:BFRecordScreenController?
    var recordEndCallBack : recordEndCallBack?

    weak var assetPlayer: AVPlayer?
    weak var recordPlayer : AVPlayer?
    var progreddL : UILabel?
    var progressThumV: BFVideoThumbProgressView?
    
    var recordItem : BFRecordItemModel?{
        didSet{
            progressThumV?.recordItem = recordItem
            progressThumV?.progress = .zero
        }
    }
    
    var playView : GPUImageView?
    var filter = GPUImageFilter()
    
    var currentAssetProgress: CMTime = .zero{
        didSet{
            self.dele?.currentAssetProgress = currentAssetProgress
//            BFLog(1, message: "currentAssetProgress:\(currentAssetProgress.seconds)")
        }
    }

    var recording = false
    var isPlaying = false
    // MARK: -
    func resetEnv(){
        progreddL?.text = CMTimeGetSeconds(currentAssetProgress).formatDurationToHMS()
    }
    
    func startRecord(){
        if recording{
            return
        }
        
        recording = true
//        recordItem?.voiceStickers.append(<#T##newElement: PQVoiceModel##PQVoiceModel#>)
    }

    func endRecord(){
        recording = false
    }
    
    func play(){
        
    }
    
    func pause(){
        
    }
    
    func changeRecordMaterail(){
        
    }
    
    func deleteRecord(at: CMTime) {
        
    }
    
    func cancelRecord(){
        
        
    }
    
    func recordFinished(isSuccess:Bool){
        progressThumV?.recordItem = recordItem
    }
    
    func dragEnd(){
        
    }
    
    func clean(){
        DispatchQueue.global().async {
            GPUImageContext.sharedFramebufferCache().purgeAllUnassignedFramebuffers()
        }
    }
    
    func checkCurrentPlayStatus(){
        if let voice = recordItem?.getUsedVoices().first(where: { mod in
            (mod.startCMTime - currentAssetProgress).seconds <= 0.05 && (mod.endCMTime - currentAssetProgress).seconds > 0.05
        }){
            let su = (recordPlayer?.currentItem?.asset as? AVURLAsset)?.url.lastPathComponent != (voice.wavFilePath as NSString?)?.lastPathComponent
            if (recordPlayer?.currentItem == nil) || su || (!su && !isPlaying){
                if su { // 我需要换源地址
                    recordPlayer?.pause()
                    recordPlayer?.replaceCurrentItem(with: AVPlayerItem(url: URL(fileURLWithPath: voice.wavFilePath)))
                }
                isPlaying = true
                let tt = max(CMTime.zero, currentAssetProgress - voice.startCMTime)
                BFLog(1, message: "tt:\(tt.seconds)")
                recordPlayer?.seek(to: tt , toleranceBefore: CMTime(seconds: 1, preferredTimescale: 10000), toleranceAfter: CMTime(seconds: 1, preferredTimescale: 10000), completionHandler: {[weak self] isfinished in
                    guard let wself = self else { return }
                    
                    wself.recordPlayer?.play()

                })
            }
            
        }
    }
    
    deinit {
        clean()
        BFLog(1, message: "\(self) release")
    }
}
