//
//  BFIntroduceToolView.swift
//  BFRecordScreenKit
//
//  Created by 胡志强 on 2021/11/26.
//

import Foundation
import UIKit

class BFIntroduceToolView: UIView {
    var choosedToolHandle: ((UIView) -> Void)?

    fileprivate let toolImgs = ["", "", ""]

    required init?(coder _: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

    override init(frame _: CGRect) {
        super.init(frame: CGRect(x: 0, y: 0, width: 40, height: 40 * toolImgs.count))
        isUserInteractionEnabled = true
        clipsToBounds = true

        for i in 0..<toolImgs.count {
            let btn = UIButton(frame: CGRect(x: 0, y: i * 40, width: 40, height: 40))
            btn.backgroundColor = UIColor.randomColor()
            btn.setTitle("\(i)", for: .normal)
            btn.setImage(imageInRecordScreenKit(by: toolImgs[i]), for: .normal)
            btn.addTarget(self, action: #selector(toolAction(btn:)), for: .touchUpInside)
            addSubview(btn)
        }
    }

    @objc func toolAction(btn _: UIButton) {
        let v = UILabel(frame: CGRect(x: 0, y: 0, width: 10, height: 40))
        v.backgroundColor = UIColor.randomColor()
        v.layer.shadowColor = UIColor.black.cgColor
        v.layer.shadowRadius = 3

        choosedToolHandle?(v)
    }
}
