//
//  BFVoiceCategoryCell.swift
//  BFRecordScreenKit
//
//  Created by ak on 2022/2/15.
//

import Foundation
import BFMediaKit
import BFUIKit
import BFCommonKit
import UIKit

class BFVoiceCategoryCell: UICollectionViewCell {
 
 
    lazy var nameLab: UILabel = {
        let nameLab = UILabel()
        nameLab.textColor =  UIColor.hexColor(hexadecimal: "#616161")
        nameLab.font = UIFont.systemFont(ofSize: 15, weight: .medium)
        nameLab.textAlignment = .center
        return nameLab
    }()
    
    lazy var line1:UIView = {
        let line1 = UIView.init()
        line1.backgroundColor = UIColor.white
        return line1
        
    }()
 

    override init(frame: CGRect) {
        super.init(frame: frame)
        backgroundColor = UIColor.clear
 
        contentView.addSubview(nameLab)
        
        contentView.addSubview(line1);
 
    }

    required init?(coder _: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

    @objc class func setCategory(collectionView: UICollectionView, indexPath: IndexPath) -> BFVoiceCategoryCell {
        let cell: BFVoiceCategoryCell = collectionView.dequeueReusableCell(withReuseIdentifier: "BFVoiceCategoryCell", for: indexPath) as! BFVoiceCategoryCell
        return cell
    }

    var category: BFVoiceCategoryModel? {
        didSet {
            addData()
            addLayout()
        }
    }
 
    func addData() {
        nameLab.text = category?.cateName
        nameLab.textColor = (category?.isSelected ?? false) ? UIColor.white :  UIColor.hexColor(hexadecimal: "#616161")
        line1.isHidden = (category?.isSelected ?? false) ? false:  true
     
    }

    func addLayout() {
        nameLab.snp.makeConstraints { make in
            make.left.equalToSuperview()
            make.width.equalToSuperview()
            make.height.equalToSuperview()
            make.top.equalToSuperview()

        }
        
        let itemWidth = sizeWithText(text: nameLab.text ?? "", font: UIFont.systemFont(ofSize: 15), size: CGSize(width: CGFloat.greatestFiniteMagnitude, height:15)).width
        
        line1.snp.remakeConstraints { make in
            make.width.equalTo(itemWidth)
            make.centerX.equalTo(nameLab.snp.centerX)
            make.height.equalTo(2)
            make.top.equalTo(nameLab.snp.bottom).offset(-2)

        }
 
    }
}


class BFVoiceCategoryModel: NSObject {
    
    var cateName:String = ""
    var cateID:Int = 0
    var isSelected:Bool = false
    
    
}
