//
//  BFRecordScreenViewModel.swift
//  Pods
//
//  Created by ak on 2021/12/7.
//

import BFCommonKit
import BFMediaKit
import BFNetRequestKit
import Foundation
import ObjectMapper
import RealmSwift

public class BFRecordScreenViewModel: NSObject {
    /// 取文本转语言 token
    /// - Parameter completeHander: completeHander description
    public class func getNlsAccessToken(completeHander: @escaping (_ token: String, _ appkey: String) -> Void) {
        let currentLanguage = BFLocalizedUtil.currentLanguage()
        BFLog(2, message: "当前的系统语言是：\(currentLanguage)")
        let nowTime: TimeInterval = Date().timeIntervalSince1970
        //token = "5d96258dcea34d7b91576031cd25a9ba"; 返回数据
        // expireTime = 1601376826000; //1601377050000;
        let saveToken: Dictionary? = getUserDefaults(key: currentLanguage) as? [String: Any] ?? nil
        if saveToken != nil && Double(saveToken!["expireTime"] as! Double) > nowTime * 1000 {
            BFLog(message: "nls token 还有效期内不用重新请求 \(String(describing: saveToken!["expireTime"])) nowTime:\(nowTime * 1000)")
            completeHander(saveToken!["token"] as! String, saveToken!["appkey"] as! String)
            return
        }

        BFNetRequestAdaptor.getRequestData(url: PQENVUtil.shared.clipapiapi + getNlsAccessTokenForJiangjieApp, parames: ["languageCode": currentLanguage], commonParams: commonParams()) { response, _, _, _ in

            if let response = response as? [String: Any], let token = response["token"] as? String, let appkey = response["appkey"] as? String {
                let nowTime: TimeInterval = Date().timeIntervalSince1970

                BFLog(message: "nowTime is \(nowTime) token is \(token)")
                saveUserDefaults(key: currentLanguage, value: response)

                completeHander(token, appkey)
            } else {
                completeHander("", "")
            }
        }
    }

    // 取发音人列表数据
    class func getAllVoiceCates(completeHander: @escaping (_ categorys: [BFVoiceCategoryModel], _ voices: Dictionary<String, [PQVoiceModel]>) -> Void) {
        BFNetRequestAdaptor.getRequestData(url: PQENVUtil.shared.clipapiapi + listAllCateVoicesUrl, parames: nil, commonParams: commonParams()) { response, _, _, _ in

            var categorys: [BFVoiceCategoryModel] = Array()
            var voccesDic: Dictionary<String, [PQVoiceModel]> = Dictionary()
            if response != nil, !(response is NSNull) {
                for voices in response as! [[String: Any]] {
                    var voicesData: [PQVoiceModel] = Array()
                    let cateName = voices["cateName"] as? String ?? ""
                    let cateId = voices["cateId"] as? Int ?? 0
                    BFLog(message: "cateName is \(cateName) cateId is \(cateId)")
                    let category = BFVoiceCategoryModel()
                    category.cateName = cateName
                    category.cateID = cateId
                    categorys.append(category)
                    for voice in voices["voiceDatas"] as! [[String: Any]] {
                        if voice.keys.contains("channel"), "\(voice["channel"] ?? "")" == "aliyun", voice.keys.contains("appEnable"), "\(voice["appEnable"] ?? "")" == "1" ,(voice["voice"] as? String ?? "") != "zhitian" {
                            let voiceModel = PQVoiceModel()
                            voiceModel.voice = voice["voice"] as? String ?? ""
                            voiceModel.name = voice["name"] as? String ?? ""
                            voiceModel.cateId = voice["cateId"] as? Int ?? 0
                            voiceModel.avatarUrl = voice["avatarUrl"] as? String ?? ""
                            voiceModel.gender = voice["gender"] as? Int ?? 0
                            voiceModel.channel = voice["channel"] as? String ?? ""
                            voiceModel.qualityFlag = voice["qualityFlag"] as? Int ?? 0
                            let azureStyleConfigStr: String = voice["azureStyleConfig"] as? String ?? ""
                            let congfigArray = jsonStringToArray(azureStyleConfigStr)
                            BFLog(message: " voiceModel.name is \(voiceModel.name)")
                            if congfigArray?.count ?? 0 > 0 {
                                BFLog(message: "\(voiceModel.name) 有语气设置 azureStyleConfig is\(String(describing: voiceModel.azureStyleConfig))")
                                for dic in congfigArray! {
                                    let azureStyleModel = PQAzureStyleModel()
                                    azureStyleModel.name = dic["name"] ?? ""
                                    azureStyleModel.style = dic["style"] ?? ""
                                    azureStyleModel.isSelected = false
                                    voiceModel.azureStyleConfig.append(azureStyleModel)

                                    let statusLabelText: String = azureStyleModel.name

                                    let size = CGSize(width: CGFloat(MAXFLOAT), height: 12)

                                    let strSize = statusLabelText.boundingRect(with: size, options: .usesLineFragmentOrigin, attributes: [NSAttributedString.Key.font: UIFont.systemFont(ofSize: 16)], context: nil).size

                                    azureStyleModel.showWith = strSize.width
                                }
                            }
                            voicesData.append(voiceModel)
                        }
                    }

                    voccesDic[cateName] = voicesData
                }
                completeHander(categorys, voccesDic)

            } else {
                completeHander(categorys, voccesDic)
            }
        }
    }
}
