//
//  AppDelegate.swift
//  BFRecordScreenKit
//
//  Created by harry on 11/23/2021.
//  Copyright (c) 2021 harry. All rights reserved.
//

import BFCommonKit
import BFMaterialKit
import UIKit

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {
    var window: UIWindow?

    func application(_: UIApplication, didFinishLaunchingWithOptions _: [UIApplicationLaunchOptionsKey: Any]?) -> Bool {
        // Override point for customization after application launch.
        BFConfig.shared.styleColor = .nomal
        BFConfig.shared.statusBarStyle = .light
        BFConfig.shared.styleBackGroundColor = UIColor.black
        BFConfig.shared.styleTitleColor = UIColor.white
        BFConfig.shared.cutViewStyleColor = UIColor.white
        BFConfig.shared.cutViewTintColor = UIColor.black
        BFConfig.shared.pointEditNamalBackgroundColor = UIColor.hexColor(hexadecimal: "#1A1A1A")
        BFMaterialConfig.shared.materialDeleteImage = UIImage.moduleImage(named: "icon_search_delete", moduleName: "BFMaterialKit") ?? UIImage()
        BFConfig.shared.cutDurationColor = UIColor(red: 238.0 / 255.0, green: 0 / 255.0, blue: 81.0 / 255.0, alpha: 0.1)
        BFConfig.shared.hiddenMusicMask = false
        BFConfig.shared.otherTintColor = UIColor.hexColor(hexadecimal: "#333333")
        BFConfig.shared.statusBarStyle = .light
        BFMaterialConfig.shared.choseType = .single
        if let tbc = window?.rootViewController as? UITabBarController {
            tbc.selectedIndex = 1
            tbc.tabBar.barTintColor = .black
            tbc.tabBar.backgroundColor = .black
            tbc.tabBar.tintColor = .black

            for item in tbc.tabBar.items! {
                item.setTitleTextAttributes([.foregroundColor: UIColor.white], for: .selected)
            }
        }
        return true
    }

    func applicationWillResignActive(_: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(_: UIApplication) {
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    }

    func applicationWillEnterForeground(_: UIApplication) {
        // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    }

    func applicationDidBecomeActive(_: UIApplication) {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillTerminate(_: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    }
}
